<template>
  <div>
    <slot />
    <div class="form-wrapper-container modal-footer modal-footer--space-between">
      <template v-if="readOnly">
        <button
          data-attr="form-wrapper-container"
          class="btn-full-blue"
          :data-qa="dataQa"
          @click.prevent="closeModal"
        >
          Закрыть
        </button>
      </template>
      <template v-else>
        <div>
          <button
            data-attr="form-wrapper-container"
            class="btn-simple"
            :data-qa="dataQa"
            @click.prevent="closeModal"
          >
            Отмена
          </button>
          <button
            data-attr="form-wrapper-container"
            class="btn-full-blue"
            :disabled="submitDisabled"
            :data-qa="dataQa"
            @click.prevent="onSubmitHandler"
          >
            Сохранить
          </button>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import cloneDeep from 'clone-deep'
import { getValueFromPath } from '../../helpers/common'
import FORM_ERRORS from '../../resources/form_errors'

export default {
  name: 'FormWrapper',
  props: {
    formData: {
      type: Object,
      required: true
    },
    formModel: {
      type: Object,
      default: null
    },
    readOnly: {
      type: Boolean,
      default: false
    },
    dataQa: {
      type: String
    }
  },
  data () {
    return {
      initFormData: {}
    }
  },
  computed: {
    isValid () {
      return !this.$v.$invalid
    },
    submitDisabled () {
      return !this.isValid || !this.formIsChanged
    },
    formIsChanged () {
      return JSON.stringify(this.formData) !== JSON.stringify(this.initFormData)
    },
    stateErrors () {
      let _this = this

      const compareRules = (RULES = [], RULES_VALIDATOR = {}, key) => {
        let errors = {}

        Object.keys(RULES)
          .forEach((rule) => {
            let error = RULES_VALIDATOR && RULES_VALIDATOR.$error && !RULES_VALIDATOR[rule] ? RULES[rule].error || FORM_ERRORS[rule] : false

            if (error) {
              if (!errors.mainError) {
                errors.mainError = {
                  key: rule,
                  text: error || FORM_ERRORS[rule]
                }
              }

              if (!errors.totalErrors) {
                errors.totalErrors = {}
              }

              errors.totalErrors[rule] = {
                key: rule,
                text: error || FORM_ERRORS[rule]
              }
            }
          })

        return errors
      }
      const getErrors = (model, parentKeys) => {
        let errors = false

        for (let key in model) {
          if (!errors) {
            errors = {}
          }

          let isEachInChild = model[key].validator && model[key].validator.$each
          let tempParentKeys = `${parentKeys}.${key !== 'nested_fields' ? key : ''}`

          const RULES_VALIDATOR = getValueFromPath({
            data: _this.$v && _this.$v.formData,
            path: tempParentKeys,
            processEach: !isEachInChild
          })

          let RULES = model[key].validator

          if (model[key].nested_fields) {
            errors[key] = getErrors(model[key].nested_fields, tempParentKeys)
          }

          if (model[key].validator) {
            errors[key] = compareRules(RULES, RULES_VALIDATOR, key)

            if (model[key].validator.$each && RULES_VALIDATOR && RULES_VALIDATOR) {
              const EACH_DATA = getValueFromPath({
                data: _this.$v && _this.$v.formData,
                path: tempParentKeys
              })
              EACH_DATA.forEach((rule, index) => {
                errors[key][index] = getErrors(model[key].validator.$each, `${tempParentKeys}.${index}`)
              })
            }
          }
        }

        return errors
      }

      return getErrors(this.formModel, '')
    },
    parentModal () {
      const getParent = (component) => {
        if (component.$options && component.$options.name && component.$options.name === 'ObModal') {
          return component
        }

        if (!component || !component.$parent) {
          return null
        } else {
          return getParent(component.$parent)
        }
      }

      return getParent(this.$parent)
    }
  },
  watch: {
    'parentModal.visible' (value) {
      if (value) {
        this.initFormData = cloneDeep(this.formData)
        this.$v && this.$v.$reset()
      }
    }
  },
  mounted () {
    this.initFormData = cloneDeep(this.formData)
  },
  validations () {
    let generateValidator = (model) => {
      let result = {}

      for (let key in model) {
        if (model[key].validator) {
          result[key] = {}

          Object.keys(model[key].validator).forEach((rule) => {
            result[key][rule] = model[key].validator[rule].method || model[key].validator[rule]
          })

          if (model[key].validator.$each) {
            result[key].$each = { ...generateValidator(model[key].validator.$each) }
          }
        } else if (model[key].nested_fields) {
          result[key] = generateValidator(model[key].nested_fields)
        }
      }

      return result
    }

    let validator = generateValidator(this.formModel || {})

    return {
      formData: {
        ...validator
      }
    }
  },
  methods: {
    onSubmitHandler () {
      this.$emit('submit', { data: this.formData })
    },
    closeModal () {
      if (this.parentModal) {
        this.parentModal.close()
      } else {
        this.$emit('cancel')
      }
    }
  }
}
</script>
